<template>
  <div :class="[$style.transactionItemWrapper]">
    <div :class="[$style.categoryIconWrapper]">
      <img :src="icon" :alt="transaction.category.name" :class="[$style.categoryIcon]">
    </div>
    <span :class="[$style.categoryName]">{{ transaction.category.name }}</span>
    <span :class="[$style.time]">{{ time }}</span>
    <span :class="[$style.sum, transaction.category.type === 'spending' ? $style.red : $style.green]">{{ formattedSum }}</span>
  </div>
</template>

<style module>
.transactionItemWrapper {
  max-width: 600px;
  margin: 5px;
  padding: 10px;
  display: grid;
  grid-template-rows: 1fr 1fr;
  grid-template-columns: 60px 3fr 1fr;
  grid-template-areas:
    "categoryIcon categoryName sum"
    "categoryIcon date         sum";
}
.categoryIconWrapper {
  grid-area: categoryIcon;
  width: 48px;
  height: 48px;
  overflow: hidden;
  border-radius: 50%;
  justify-self: left;
  align-self: center;
}
.categoryIconWrapper .categoryIcon {
  width: 58px;
  height: auto;
  object-fit: cover;
  object-position: -5px -5px;
}
.categoryName {
  grid-area: categoryName;
}
.time {
  grid-area: date;
  color: #494949;
  font-size: .8rem;
  align-self: end;
}
.sum {
  grid-area: sum;
  font-size: 1.1rem;
  justify-self: right;
  align-self: center;
}
.red {
  color: #914948;
}
.green {
  color: #4b885f;
}
</style>

<script>
import moment from 'moment';

export default {
  props: {
    transaction: {
      type: Object,
    },
  },
  computed: {
    time() {
      return moment(this.transaction.created_at).format('hh:mm');
    },
    icon() {
      return this.transaction.category.icon_path || '/img/answer.jpg';
    },
    formattedSum() {
      const formatter = new Intl.NumberFormat('ru', {
        style: 'currency',
        currency: this.transaction.category.currency_key,
      });
      const direction = this.transaction.category.type === 'spending' ? '-' : '+';
      return direction + formatter.format(this.transaction.amount);
    },
  },
};
</script>